unit Poytap;
{
  Pytpakka-komponentti:
  - Pakka, jolla on mys CheckBox, joten se voidaan merkit.

  5.11.1997/ Tanja Partanen ja Niina Riikonen

  Muutoksia 7.11.1997/vl
    + anna_kortin OnClickin muuttaminen inherited jlkeen
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,Kortti,Pakka,APakka;

type
  TPoytap = class(TAPakka)
  private
    FActive      : boolean;
    FCheckBox    : TCheckBox;
    procedure DragArrive(o,w:TControl;data:integer);
  protected
  public
    constructor Create(AOwner:TComponent);    override;
    destructor  Destroy;                      override;
    function    GetCheck:Boolean;             virtual;
    procedure   SetCheck(check:Boolean);      virtual;
    procedure   SetActive(a:Boolean);         virtual;
    procedure   lisaa_kortti(kortti:TKortti); override;
    function    anna_kortti_i(i:integer):TKortti; override;
    function    Kelpaako(k:TKortti):boolean;  virtual;
    function    SaakoOttaa(k:TKortti):boolean;virtual;
  published
    property  Checked:Boolean read GetCheck write SetCheck;
    property  Active:Boolean  read FActive write SetActive;
    procedure PoytapClick(Sender: TObject);
    procedure PoytapDown(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
end;

procedure Register;

implementation
uses raahattava;


constructor TPoytaP.Create(AOwner:TComponent);
begin
  Inherited;
  Height   := 100;
  Width    := 73;
  FCheckBox := TCheckBox.Create(self);
  if ( FCheckBox = NIL ) then exit;
  FCheckBox.Parent    := self;
  FCheckBox.Alignment := taRightJustify;
  FCheckBox.Left      := 4;
  FCheckBox.Top       := Height;
  FCheckBox.Checked   := False;
  Checked             := False;
  Active              := True;
//  OnDragDrop          :
end;

destructor  TPoytap.Destroy;
begin
  FCheckBox.Free;
  inherited;
end;


procedure TPoytap.SetActive(a:Boolean);
begin
  FActive := a;             
//  Visible := a and (kortteja > 0);                                         // vl
end;

procedure TPoytap.SetCheck(check:Boolean);
begin
  FCheckBox.Checked := check;
end;

function TPoytap.GetCheck:Boolean;
begin
  result := FCheckbox.Checked;
end;

procedure TPoytap.lisaa_kortti(kortti:TKortti);
begin
  if( kortti = NIL ) then exit;
  inherited lisaa_kortti(kortti);
  kortti.OnMouseDown := PoytapDown;                              // siirretty/vl
  kortti.OnClick := PoytapClick;                                 // siirretty/vl
end;

function  TPoytap.anna_kortti_i(i:integer):TKortti;
var apu:TKortti;
begin
  apu := inherited anna_kortti_i(i);
  if( apu <> nil ) then begin
    apu.OnClick := nil;
    apu.OnMouseDown := nil;
  end;
  result := apu;
end;

procedure TPoytap.PoytapClick(Sender: TObject);
begin
  Checked := not Checked;
end;

function TPoytap.Kelpaako(k:TKortti):boolean;
begin
  Result := kortteja = 0;
end;

function TPoytap.SaakoOttaa(k:TKortti):boolean;
begin
  Result := true;
end;



procedure TPoytap.DragArrive(o,w:TControl;data:integer);
var p:TPoytap; k:TKortti;
begin
  if not ( o is TKortti ) then exit;
  k := ( o as TKortti );
  p := nil;
  if ( w is TKortti ) and ( w.Parent is TPoytap )  then p := w.Parent as TPoytap;
  if ( w is TPoytap ) then p := ( w as TPoytap );
  if ( p = nil ) then p := self;
  if ( not p.Kelpaako(k) ) then p := self; 
  p.Puoli := k.Nakyy;
  k.left := 0; k.top := 0;
  p.lisaa_kortti(k);
end;


procedure TPoytap.PoytapDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var k:TKortti;
begin
  if not ( Sender is TKortti ) then exit;
  k := Sender as TKortti;
  if ( not SaakoOttaa(k) ) then exit;
  RaahaaXY(anna(k),x,y,DragArrive,0);
end;

procedure Register;
begin
  RegisterComponents('GKO97', [TPoytap]);
end;

end.
