unit Kortti;
(*
  Kortti-komponentti:
  - Create:sta kaksi eri versiota, huomaa niiden vlinen ero.
  - FOwnerin muuttaminen MIELELLN harkitusti.

  5.11.1997/ Tanja Partanen ja Niina Riikonen

  Muutoksia 8.11.1997/vl
   + Kortin Owneriin liittyvt asiat pois, koska Ownewria ei nhtvsti
     voi muuttaa
   + Create2 => Create3 ja muutettu param. jrjestys AOwner ensimmiseksi
   + TKortti, josta peritn TKuvaKortti, josta peritn TPeliKortti
   + TKuvaKorttin geneeriset tiedostonimet card0n ja cardnn
   + Jos TKortti peritn, kirjoitetaan lataa ja Paint uudestaan
   + SortValue = arvo, jonka mukaan lajitellaan
   + OnFlip - event  
  Muutoksia 11.11.1997/vl
   + testit, ettei pivityst tehd jollei ole muutoksia
  Muutoksia 01.12.1997/vl
  + Kuvakortin lataaminen tiedostosta, JOS nimi pttyy .bmp.
    Muuten kortti ladataan resursseista (ks. LoadBmp-metodi).
    Resurssit (*.res) voidaan tehd esim. BC 5.02:lla *.rc tiedosto, jossa
    lukee:
      c01 BITMAP "c01.bmp"
      c02 BITMAP "c02.bmp"
      jne...
    Sitten .rc knnetn.  Tytyy pit huoli, ett kohteena on 32-bit!
    Tm onnistuu esim. tekemll projekti, jossa on vain .rc.
    Knnksen tuloksena syntyy .res, joka liitetn Pascal-tiedostoon
    esim:
    {$R kortit.res}

  Tekemtt
  - kannattaisi jakaa kahdeksi tiedostoksi, jossa toisessa
    olisi kortti ja kuvakortti ja toisessa pelikortti + valmiit
    pelikortin kuvat.
  - samoin pakan kohdalla JakoPakka kannattaisi siirt omaan
    tiedostoonsa.  
*)

interface

uses
  SysUtils,WinTypes,WinProcs,Messages,Classes,Graphics,Controls,
  Forms,Dialogs,ExtCtrls;

type
  TNakyy  = ( Piilossa, Selka, Kuva );

  TKorttiMeth = procedure (sender:TObject;nakyy:TNakyy) of object;

  TKortti = class(TPaintBox)
  private
    FArvo  : integer;
    FNakyy : TNakyy;
    FOnFlip : TKorttiMeth;
//    FOwner : TComponent;
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    constructor Create2(AOwner:TComponent;i:integer); virtual;
    procedure   SetArvo(i:integer);         virtual;
    procedure   SetNakyy(n:TNakyy);         virtual;
    procedure   Lataa;                      virtual;
//    procedure   SetOwner(c:TComponent);     virtual;
//    property    Owner:TComponent read FOwner write SetOwner;
    function SortValue : integer;           virtual;
  published
    property Arvo:integer read FArvo write SetArvo;
    property Nakyy:TNakyy read FNakyy write SetNakyy;
    property OnFlip : TKorttiMeth read FOnFlip write FOnFlip;
  end;

  TKuvaKortti = class(TKortti)
  private
    FTausta : string;
    FImageList : TImageList;
  protected
    procedure Paint; override;
  public
    constructor Create2(AOwner:TComponent;i:integer); override;
    procedure   Lataa;                      override;
    procedure   LoadBmp(bmp:TBitMap;name:string); virtual;
    function    Tiedosto:string;            virtual;
  published
    property Tausta:string read FTausta write FTausta;
  end;

  TMaa    = ( Ruutu, Hertta, Risti, Pata );

  TPeliKortti = class(TKuvaKortti)
  private
    FMaa   : TMaa;
  protected
  public
    constructor Create(AOwner: TComponent); override;
    constructor Create3(AOwner:TComponent;i:integer;maa:TMaa); virtual;
    procedure   SetArvo(i:integer);         override;
    procedure   SetMaa(m:TMaa);             virtual;
    function    Tiedosto:string;            override;
    function    SortValue : integer;        override;
  published
    property Maa:TMaa read FMaa write SetMaa;
  end;

procedure Register;

implementation

//==============================================================================
// TKortti
//==============================================================================
constructor TKortti.Create(AOwner: TComponent);
begin
  Create2(AOwner,1);
end;

constructor TKortti.Create2(AOwner:TComponent;i:integer);
begin
  inherited Create(AOwner);
  FNakyy  := Piilossa;  // Huomaa, ett kaikki kortit syntyvt piilossa oleviksi!
  Visible := False;
  FArvo   := i;
  Width   := 50;
  Height  := 100;
//  AutoSize := True;
  lataa;
end;

procedure TKortti.Paint;
var s:string; ts : TSize;
begin
  inherited;
  s := IntToStr(Arvo);
  ts := Canvas.TextExtent(s);
  Canvas.Brush.Color := Color;
  Canvas.Pen.Style := psSolid;
  Canvas.Rectangle(0,0,Width,Height);
  if ( Nakyy = Kuva ) then
    Canvas.TextOut((Width-ts.cx) div 2,(Height-ts.cy) div 2,s);
end;

function TKortti.SortValue : integer;
begin
  Result := arvo;
end;

procedure TKortti.SetArvo(i:integer);
begin
  if ( FArvo = i ) then exit;
  FArvo := i;
  Lataa;
end;

procedure TKortti.SetNakyy(n:TNakyy);
begin
  if ( FNakyy = n ) then exit;
  FNakyy := n;
  Visible := n <> Piilossa;
  Invalidate;
  if Assigned(OnFlip) then OnFlip(self,Nakyy);
//  Lataa;
end;
{
procedure TKortti.SetOwner(c:TComponent);
begin
  FOwner := c;
end;
}

procedure TKortti.Lataa;
begin
  Invalidate;
end;

//==============================================================================
// TKuvaKortti
//==============================================================================
constructor TKuvaKortti.Create2(AOwner:TComponent;i:integer);
begin
  if ( FTausta = '' ) then FTausta := 'KTausta.bmp';
  FImageList := TImageList.Create(self);
  inherited Create2(AOwner,i);
end;

procedure TKuvaKortti.LoadBmp(bmp:TBitMap;name:string);
begin
  if ( Pos('.BMP',UpperCase(name)) > 0 ) then
    bmp.LoadFromFile(name)
  else
    bmp.LoadFromResourceName(hInstance,UpperCase(name));
end;

procedure TKuvaKortti.Lataa;
var bmp  : TBitmap; // Apubittikartta
begin
  FImageList.Clear;                              // Pyyhitn vanhat kuvat pois
  bmp := TBitmap.Create;                         // Luodaan tilap. bittikartta
  LoadBmp(bmp,Tausta);                           // Luetaan tausta
  bmp.Monochrome := false;
  Width := bmp.Width;                            // Koko otetaan taustakuvasta
  Height := bmp.Height;
  FImageList.Width  := Width;                    // Samoin kuvalistan
  FImageList.Height := Height;
  FImageList.Add(bmp,nil);                       // Kuvalistan paik.0 tausta

  LoadBmp(bmp,Tiedosto);
  bmp.Monochrome := false;
  FImageList.Add(bmp,nil);                       // Kuvalistan paik.1 kuva
  bmp.Free;
  Invalidate;
end;

procedure TKuvaKortti.Paint;
var index : integer;
begin
  index := 0; if ( Nakyy = Kuva ) then index := 1; // Kumpiko kuva pit piirt
  FImageList.Draw(Canvas,0,0,index);
end;

function TKuvaKortti.Tiedosto:string;
var k:string;
begin
  k := 'card';
  if ( Arvo < 10 ) then k := k + '0';
  k := k + IntToStr(Arvo) + '.bmp';
  result := k;
end;

//==============================================================================
// TPeliKortti
//==============================================================================
{$R PELIKORT.RES}

constructor TPeliKortti.Create(AOwner: TComponent);
begin
  Create3(AOwner,1,Ruutu);
end;

constructor TPeliKortti.Create3(AOwner:TComponent;i:integer;maa:TMaa);
begin
  FMaa := maa;
  FTausta := 'KTausta';                            // Ladataan resursseista
  inherited Create2(AOwner,i);
end;

procedure TPeliKortti.SetMaa(m:TMaa);
begin
  if ( FMaa = m ) then exit;
  FMaa := m;
  Lataa;
end;

procedure TPeliKortti.SetArvo(i:integer);
begin
  if ( FArvo = i ) then exit;
  case i of
    1 .. 13 : FArvo := i;
  else exit;
  end;
  Lataa;
end;

function TPeliKortti.Tiedosto:string;
var k:string;
begin
  case Maa of
    Ruutu  : k := 'd';
    Hertta : k := 'h';
    Risti  : k := 'c';
    Pata   : k := 's';
  end;
  if ( Arvo < 10 ) then k := k + '0';
  Result := k + IntToStr(Arvo); // + '.bmp';

//  Result := Format('%s%02d',[k,Arvo]);
end;

function TPeliKortti.SortValue : integer;
begin
  Result := arvo-1 + Ord(maa)*13;
end;

procedure Register;
begin
  RegisterComponents('GKO97', [TKortti,TKuvaKortti,TPeliKortti]);
end;

end.
