unit raahattava;
{
  Olio, joka on tehty raahaamaan muita olioita paikasta toiseen.
  Vesa Lappalainen 17.01.1998

  Liikuttaa olion olion nykyisest paikasta hiiren liikkeiden
  mukaan.
  Saadaan tapahtuma jokaisesta liikahduksesta (OnMove) sek perille
  saapumisesta (OnArrive).

  Jos irtipstpaikalla on kontrolli, jossa on OnDragGdrop-tapahtuman
  ksittelij, niin tt kutsutaan Arrive-tapahtuman jlkeen.
  Jos joko Arrive tai OnDragDrop muuttaa olion Parenttia, niin
  raahattava ei en koske olioon.  Jos olion Parenttia ei muuteta,
  laittaa raahattava olion parentiksi sen WinControllin, jonka plle
  olio pudotettiin, tai jos WinControllia ei lydy, niin olio palautetaan
  alkuperiseen paikkaansa ja alkuperinen Parent asetetaan takaisin.

  Arrrive-tapahtuman parametrit:
    TRaahaavaMeth = procedure (o,wnd:TControl;data:integer) of object;
      o      - olio, joka saapui raahattavan mukana
      wnd    - kontrolli, jonka plle raahattiin
      data   - vapaamuotoinen kutsussa annettu data

  Kytt helpottamaan on tehty kolme funktiota, jotka luovat raahattavan
  olio, siirtvt siirrettvn olion raahattavan sislle ja ilmoittavat
  lopuksi kun siirto on valmis.

   function Raahaa(OWhat : TControl; arrive:TRaahaavaMeth;
                  data:integer) : boolean;
   function RaahaaXY(OWhat : TControl; x,y:integer; arrive:TRaahaavaMeth;
                  data:integer) : boolean;
   function RaahaaPt(OWhat : TControl; dp:TPoint; arrive:TRaahaavaMeth;
                  data:integer) : boolean;
  Parametrit:
    OWhat    - siirrettv olio
    f        - ikkuna jonka sisll siirto tehdn
    ToPt     - raahattavan sisll, yleens thn kannattaa laittaa
               MouseDown-tapahtumasta saatu hiiren paikka
    arrive   - metodi, joka ksittelee valmiin siirron
    data     - vapaasti kytettv sana, joka saadaan kyttn siirron loputtua

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TRaahaavaMeth = procedure (o,wnd:TControl;data:integer) of object;
  TRaahaavaMoveMeth = procedure (o:TControl;pt:TPoint;data:integer) of object;

  TDragControl = class(TControl)
  published
//    procedure OnMouseMove;
//    procedure OnMouseUp;
  end;

  TRaahaava = class(TWinControl)
  private
    FOnArrive : TRaahaavaMeth;
    FOnMove   : TRaahaavaMoveMeth;
    FObject   : TDragControl;
    FDp       : TPoint;
    FFrom     : TPoint;
    FData     : Integer;
    FOrigo    : TPoint;

    FOldMove  : TMouseMoveEvent;
    FOldUp    : TMouseEvent;
    FOldParent: TWinControl;
    FMoving   : Boolean;

    FAutoDestroy : boolean;
    procedure ObjMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ObjMouseUp(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
  protected
  public
    constructor Create(AOwner:TComponent);                  override;
    destructor  Destroy;                                    override;
    function KuljetaPt(OWhat : TControl; f:TWinControl;ToPt:TPoint;
                       data : integer) : boolean; virtual;
    function Kuljeta(OWhat : TControl; dp:TPoint; data:integer):boolean; virtual;
    function Moving : boolean;                              virtual;
  published
    property OnArrive : TRaahaavaMeth read FOnArrive write FOnArrive;
    property OnMove   : TRaahaavaMoveMeth read FOnMove write FOnMove;
  end;



function Raahaa(OWhat : TControl; arrive:TRaahaavaMeth;
               data:integer) : boolean;
function RaahaaXY(OWhat : TControl; x,y:integer; arrive:TRaahaavaMeth;
               data:integer) : boolean;
function RaahaaPt(OWhat : TControl; dp:TPoint; arrive:TRaahaavaMeth;
               data:integer) : boolean;

procedure Register;

implementation

constructor TRaahaava.Create(AOwner:TComponent);
begin
  inherited;
//  BevelInner := bvNone;
//  BevelOuter := bvNone;
//  ParentColor := true;
  FAutoDestroy := false;
  FOnMove := nil;
  FOnArrive := nil;
  FOrigo.x := 0; FOrigo.y := 0;
end;

destructor  TRaahaava.Destroy;
begin
  inherited;
end;

function TRaahaava.Moving : boolean;
begin
  Result := FMoving;
end;


procedure TRaahaava.ObjMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if ( sender <> FObject ) then exit;
  Left := Left + x - FDp.x;
  Top :=  Top  + y - Fdp.y;
end;

function FindControlAtPos(w:TWinControl;const Pos: TPoint;
                         AllowDisabled: Boolean; nc:TControl): TControl;
var
  I: Integer;
  P: TPoint;
begin
  with w do
    for I := ControlCount - 1 downto 0 do
    begin
      Result := Controls[I];
      if ( Result <> nc ) then with Result do
      begin
        P := Point(Pos.X - Left, Pos.Y - Top);
        if PtInRect(ClientRect, P) and
          ((csDesigning in ComponentState) and (Visible or
          not (csNoDesignVisible in ControlStyle)) or
          (Visible and (Enabled or AllowDisabled) and
          (Perform(CM_HITTEST, 0, Longint(PointToSmallPoint(P))) <> 0))) then
          Exit;
      end;
    end;
  Result := nil;
end;

procedure TRaahaava.ObjMouseUp(Sender: TObject; Button: TMouseButton;
                    Shift: TShiftState; X, Y: Integer);
var wnd,ctl : TControl; dwnd : TDragControl;
    parw : TWinControl;
    pt : TPoint;
begin
//  FObject.Parent := nil;
  FObject.OnMouseMove := FOldMove;
  FObject.OnMouseUp := FOldUp;
  ReleaseCapture();
  pt := Parent.ScreenToClient(ClientToScreen(FOrigo));
  inc(pt.x,x); inc(pt.y,y);
//  wnd := Parent.ControlAtPos(pt,true);
  wnd := FindControlAtPos(Parent,pt,true,self);
  ctl := wnd;
  parw := nil;
  while ( ctl is TWinControl ) do begin
    wnd  := ctl;
    parw := ctl as TWinControl;
    pt := parw.ScreenToClient(ClientToScreen(FOrigo));
    inc(pt.x,x); inc(pt.y,y);
    ctl  := FindControlAtPos(parw,pt,true,self);
  end;

  if ( ctl <> nil ) then wnd := ctl;

  if ( Assigned(FOnArrive) ) then OnArrive(FObject,wnd,FData);

  if ( wnd <> nil ) then begin
    dwnd := TDragControl(wnd);
    if ( assigned(dwnd.OnDragDrop) ) then
      dwnd.OnDragDrop(wnd,FObject,pt.x,pt.y);
  end;

  if FObject.Parent = self then // Jos vastuuta ei ole otettu
    if parw <> nil then begin // Jos lytyi uusi, joka kelpaa vanhemmaksi
      pt := parw.ScreenToClient(ClientToScreen(FOrigo));
      FObject.Parent := parw;
      FObject.Left   := pt.x;
      FObject.Top    := pt.y;
    end
    else begin               // Muuten alkuperinen paikka ja isnt
      FObject.Parent := FOldParent;
      FObject.Left   := FFrom.x;
      FObject.Top    := FFrom.y;
    end;

  if ( FAutoDestroy ) then Free;
end;

function TRaahaava.KuljetaPt(OWhat : TControl; f:TWinControl;ToPt:TPoint;
                             data : integer) : boolean;
var pt : TPoint;
begin
  Result := false;
  if ( OWhat = nil ) then exit;
  FObject := TDragControl(OWhat);
  if ( Moving ) then exit;
  FDp := ToPt;
  Parent := f;
  Visible := true;
  Color := FObject.Color;
  FData := data;
  FOldMove   := FObject.OnMouseMove;
  FOldUp     := FObject.OnMouseUp;
  FFrom.x   := FObject.Left; FFrom.y := FObject.Top;
  FOldParent := FObject.Parent;
  FObject.OnMouseMove := ObjMouseMove;
  FObject.OnMouseUp := ObjMouseUp;
  pt := Parent.ScreenToClient(FObject.ClientToScreen(FOrigo));
  FObject.Parent := self;
  FObject.Top := 0;
  FObject.Left := 0;
  FMoving := true;
  Width := FObject.Width;
  Height := FObject.Height;
  Left := pt.x;
  Top := pt.y;
  SetCapture(handle);
//  BeginDrag(false);
end;

function TRaahaava.Kuljeta(OWhat : TControl; dp:TPoint; data : integer) : boolean;
var p : TObject; f:TForm; pt:TPoint;
begin
  Result := false;
  if ( OWhat = nil ) then exit;
  if ( Moving ) then exit;
  p := OWhat;
  while ( p<> nil ) and (not ( p is TForm )) do
    p := (p as TControl).Parent;
  if ( p = nil ) then exit;
  f := p as TForm;

  pt := f.ScreenToClient(OWhat.ClientToScreen(FOrigo));

  Result := KuljetaPt(OWhat,f,dp,data)
end;

function InitRaahaava(var l:TRaahaava;f:TComponent;
                      arrive:TRaahaavaMeth) : boolean;
begin
  Result := false;
  l := TRaahaava.Create(f);
  if ( l = nil ) then exit;
  l.Visible := false;
  l.FAutoDestroy := true;
  l.OnArrive := arrive;
  Result := true;
end;


function RaahaaPt(OWhat : TControl; dp:TPoint; arrive:TRaahaavaMeth;
               data:integer) : boolean;
var Raahaava : TRaahaava;
begin
  Result := false;
  if ( OWhat = nil ) then exit;
  if not InitRaahaava(Raahaava,OWhat.Owner,arrive) then exit;
  Result := Raahaava.Kuljeta(OWhat,dp,data);
end;

function RaahaaXY(OWhat : TControl; x,y:integer; arrive:TRaahaavaMeth;
               data:integer) : boolean;
begin
  Result := RaahaaPt(OWhat,Point(x,y),arrive,data);
end;

function Raahaa(OWhat : TControl; arrive:TRaahaavaMeth;
               data:integer) : boolean;
begin
  Result := RaahaaXY(OWhat,0,0,arrive,data);
end;

procedure Register;
begin
  RegisterComponents('GKO97', [TRaahaava]);
end;

end.
