unit raahausp;
{
  Raahauspakka-komponentti:
  - Pakka, josta voidaan raahata kortteja

  Tekij:  Vesa Lappalainen
  Milloin: 16.1.1998

  Muutoksia
    +
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,Kortti,Pakka,APakka;

type
  TRaahausPakka = class(TAPakka)
  private
    procedure DragArrive(o,w:TControl;data:integer);
  protected
  public
    constructor Create(AOwner:TComponent);        override;
    destructor  Destroy;                          override;
    procedure   lisaa_kortti(kortti:TKortti);     override;
    function    anna_kortti_i(i:integer):TKortti; override;
    function    Kelpaako(k:TKortti):boolean;      virtual;
    function    SaakoOttaa(k:TKortti):boolean;    virtual;
  published
    procedure RaahausDown(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
end;

procedure Register;

implementation
uses raahattava;


constructor TRaahausPakka.Create(AOwner:TComponent);
begin
  Inherited;
  Height   := 100;
  Width    := 73;
end;

destructor  TRaahausPakka.Destroy;
begin
  inherited;
end;


procedure TRaahausPakka.lisaa_kortti(kortti:TKortti);
begin
  if( kortti = NIL ) then exit;
  inherited lisaa_kortti(kortti);
  kortti.OnMouseDown := RaahausDown;
end;

function  TRaahausPakka.anna_kortti_i(i:integer):TKortti;
var apu:TKortti;
begin
  apu := inherited anna_kortti_i(i);
  if( apu <> nil ) then begin
    apu.OnClick := nil;
    apu.OnMouseDown := nil;
  end;
  result := apu;
end;

function TRaahausPakka.Kelpaako(k:TKortti):boolean;
begin
  Result := kortteja < MaxKortteja;
end;

function TRaahausPakka.SaakoOttaa(k:TKortti):boolean;
begin
  Result := true;
end;



procedure TRaahausPakka.DragArrive(o,w:TControl;data:integer);
var p:TRaahausPakka; k:TKortti;
begin
  if not ( o is TKortti ) then exit;
  k := ( o as TKortti );
  p := nil;
  if ( w is TKortti ) and ( w.Parent is TRaahausPakka )  then p := w.Parent as TRaahausPakka;
  if ( w is TRaahausPakka ) then p := ( w as TRaahausPakka );
  if ( p = nil ) then p := self;
  if ( not p.Kelpaako(k) ) then p := self; 
  p.Puoli := k.Nakyy;
  k.left := 0; k.top := 0;
  p.lisaa_kortti(k);
end;


procedure TRaahausPakka.RaahausDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var k:TKortti;
begin
  if ( Button <> mbLeft ) then exit;
  if not ( Sender is TKortti ) then exit;
  k := Sender as TKortti;
  if ( not SaakoOttaa(k) ) then exit;
  RaahaaXY(anna(k),x,y,DragArrive,0);
end;

procedure Register;
begin
  RegisterComponents('GKO97', [TRaahausPakka]);
end;

end.
